/* $Id: StringTokenizer.hh,v 1.1 2002/04/27 12:59:33 sdevaux Exp $
 *
 * NaJA
 * Tabs = 4 chars
 * copyright (C) 2002 Sebastien Devaux
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *              Sebastien Devaux <sebastien.devaux@laposte.net>
 */ 
#ifndef __StringTokenizer_hh__
#define __StringTokenizer_hh__

#include "naja.hh"
#include "lang/String.hh"

PACKAGE_USE(najaLang)

PACKAGE_BEGIN(najapiUtil)

/**
 * String token splitting utility. 
 */
class StringTokenizer : public Object {
	private:
//---------------------------------------------
// PRIVATE PROPERTIES
		/** the input string */
		NAJA<String> toSplit;
		/** token delimiter */
		NAJA<String> separators;
		/** next token to read index inside input string */
		int index;
		/** input string last charactere index */
		int max;
//---------------------------------------------
// PRIVATE METHODS
		void nextSeparator();
		void nextNonSeparator();
		
	public:
//---------------------------------------------
// PBLIC METHODS
		/**
		 * Create a tokenizer using defaults delimiters : space, tabs an 
		 * new line.
		 * @param src the string to tokenize
		 */ 
		StringTokenizer(NAJA<String> src);
		/**
		 * Create a string tokenizer
		 * @param src input string
		 * @param del delimiters
		 */
		StringTokenizer(NAJA<String> src, NAJA<String> del);
		virtual ~StringTokenizer() {};
		/**
		 * Is there any more tokens ?
		 * @return false when no more tokens are available, true otherwise.
		 */ 
		virtual boolean hasMoreTokens();
		/**
		 * get the next token
		 * @return the next token or NULL when no more tokens are available
		 */ 
		virtual NAJA<String> nextToken();
};	

PACKAGE_END
#endif
