/* $Id: StringTokenizer.cc,v 1.1 2002/04/27 12:59:33 sdevaux Exp $
 *
 * NaJA
 * Tabs = 4 chars
 * copyright (C) 2002 Sebastien Devaux
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *              Sebastien Devaux <sebastien.devaux@laposte.net>
 */
#include "util/StringTokenizer.hh"

PACKAGE_BEGIN(najaUtil)

//-----------------------------------------------------------
// New StringTokenizer using defaults delimiters
StringTokenizer::StringTokenizer(NAJA<String> src) {
	StringTokenizer(src,new String(" \t\n"));
}		
//-----------------------------------------------------------
// New StringTokenizer
StringTokenizer::StringTokenizer(NAJA<String> src,NAJA<String> del) {
	MSTART("StringTokenizer::StringTokenizer(\""<<src<<"\",\""<<del<<"\")")
	toSplit=src;
	separators=del;
	index=0;
	max=toSplit->length();
	nextNonSeparator();
	MEND
}
//-----------------------------------------------------------
// set index to next separator
void StringTokenizer::nextSeparator() {
	MSTART("StringTokenizer::gotoNext()")
	for(char c=toSplit->charAt(index);
			 index<max&&separators->indexOf(c)<0;
			 c=toSplit->charAt(++index));
	MEND
}	
//-----------------------------------------------------------
// set index to next non-separator
void StringTokenizer::nextNonSeparator() {
	MSTART("StringTokenizer::nextNonSeparator()")
	for(char c=toSplit->charAt(index);
			 index<max&&separators->indexOf(c)>=0;
			 c=toSplit->charAt(++index));
	MEND
}	
//-----------------------------------------------------------
// any more elements ? 
boolean StringTokenizer::hasMoreTokens() {
	MSTART("StringTokenizer::hasMoreTokens()")
	MRETURN(index<max)
}
//-----------------------------------------------------------
// get next element
NAJA<String> StringTokenizer::nextToken() {
	MSTART("StringTokenizer::nextToken()")
	if (hasMoreTokens()) {
		int start=index;
		nextSeparator();
		int end=index;
		nextNonSeparator();
		MRETURN(toSplit->substring(start,end))
	} 
	else {
		MRETURN(NULL)
	}	
}	

PACKAGE_END
